Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osgGA::TerrainManipulator Class Reference

Inheritance diagram for osgGA::TerrainManipulator:

[legend]
List of all members.

## Public Types
enum | RotationMode { ELEVATION_AZIM_ROLL, ELEVATION_AZIM }
## Public Member Functions
| TerrainManipulator ()
virtual const char * | className () const
| return the name of the object's class type.
void | setRotationMode (RotationMode mode)
RotationMode | getRotationMode () const
virtual void | setByMatrix (const osg::Matrixd &matrix)
| set the position of the matrix manipulator using a 4x4 Matrix.
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
| set the position of the matrix manipulator using a 4x4 Matrix.
virtual osg::Matrixd | getMatrix () const
| get the position of the manipulator as 4x4 Matrix.
virtual osg::Matrixd | getInverseMatrix () const
| get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.
virtual osgUtil::SceneView::FusionDistanceMode | getFusionDistanceMode () const
| Get the FusionDistanceMode.
virtual float | getFusionDistanceValue () const
| Get the FusionDistanceValue.
virtual void | setNode (osg::Node *)
| Attach a node to the manipulator.
virtual const osg::Node * | getNode () const
| Return node if attached.
virtual osg::Node * | getNode ()
| Return node if attached.
virtual void | home (const GUIEventAdapter &ea, GUIActionAdapter &us)
| Move the camera to the default position.
virtual void | init (const GUIEventAdapter &ea, GUIActionAdapter &us)
| Start/restart the manipulator.
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &us)
| handle events, return true if handled, false otherwise.
virtual void | getUsage (osg::ApplicationUsage &usage) const
| Get the keyboard and mouse usage of this manipulator.
## Protected Member Functions
virtual | ~TerrainManipulator ()
void | flushMouseEventStack ()
| Reset the internal GUIEvent stack.
void | addMouseEvent (const GUIEventAdapter &ea)
| Add the current mouse GUIEvent to internal stack.
void | computePosition (const osg::Vec3d &eye, const osg::Vec3d &lv, const osg::Vec3d &up)
bool | calcMovement ()
| For the give mouse movement calculate the movement of the camera.
void | trackball (osg::Vec3 &axis, double &angle, double p1x, double p1y, double p2x, double p2y)
double | tb_project_to_sphere (double r, double x, double y)
bool | isMouseMoving ()
| Check the speed at which the mouse is moving.
void | clampOrientation ()
## Protected Attributes
osg::ref_ptr< const GUIEventAdapter > | _ga_t1
osg::ref_ptr< const GUIEventAdapter > | _ga_t0
osg::ref_ptr< osg::Node > | _node
RotationMode | _rotationMode
bool | _thrown
osg::Vec3d | _center
osg::Quat | _rotation
float | _distance
osg::Vec3d | _previousUp

## Member Enumeration Documentation

enum osgGA::TerrainManipulator::RotationMode

  | Enumeration values:
  ELEVATION_AZIM_ROLL |
  ELEVATION_AZIM |

## Constructor & Destructor Documentation

osgGA::TerrainManipulator::TerrainManipulator | ( |  | ) |

virtual osgGA::TerrainManipulator::~TerrainManipulator | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

void osgGA::TerrainManipulator::addMouseEvent | ( | const GUIEventAdapter & | ea | ) | `[protected]`

| Add the current mouse GUIEvent to internal stack.

bool osgGA::TerrainManipulator::calcMovement | ( |  | ) | `[protected]`

| For the give mouse movement calculate the movement of the camera. Return true is camera has moved and a redraw is required.

void osgGA::TerrainManipulator::clampOrientation | ( |  | ) | `[protected]`

virtual const char* osgGA::TerrainManipulator::className | ( |  | ) | const`[inline, virtual]`

| return the name of the object's class type. Must be defined by derived classes. Reimplemented from osgGA::MatrixManipulator.

void osgGA::TerrainManipulator::computePosition | ( | const osg::Vec3d & | eye,
|  | const osg::Vec3d & | lv,
|  | const osg::Vec3d & | up
| ) | `[protected]`

void osgGA::TerrainManipulator::flushMouseEventStack | ( |  | ) | `[protected]`

| Reset the internal GUIEvent stack.

virtual osgUtil::SceneView::FusionDistanceMode osgGA::TerrainManipulator::getFusionDistanceMode | ( |  | ) | const`[inline, virtual]`

| Get the FusionDistanceMode. Used by SceneView for setting up setereo convergence. Reimplemented from osgGA::MatrixManipulator.

virtual float osgGA::TerrainManipulator::getFusionDistanceValue | ( |  | ) | const`[inline, virtual]`

| Get the FusionDistanceValue. Used by SceneView for setting up setereo convergence. Reimplemented from osgGA::MatrixManipulator.

virtual osg::Matrixd osgGA::TerrainManipulator::getInverseMatrix | ( |  | ) | const`[virtual]`

| get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix. Implements osgGA::MatrixManipulator.

virtual osg::Matrixd osgGA::TerrainManipulator::getMatrix | ( |  | ) | const`[virtual]`

| get the position of the manipulator as 4x4 Matrix. Implements osgGA::MatrixManipulator.

virtual osg::Node* osgGA::TerrainManipulator::getNode | ( |  | ) | `[virtual]`

| Return node if attached. Reimplemented from osgGA::MatrixManipulator.

virtual const osg::Node* osgGA::TerrainManipulator::getNode | ( |  | ) | const`[virtual]`

| Return node if attached. Reimplemented from osgGA::MatrixManipulator.

RotationMode osgGA::TerrainManipulator::getRotationMode | ( |  | ) | const`[inline]`

virtual void osgGA::TerrainManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const`[virtual]`

| Get the keyboard and mouse usage of this manipulator. Reimplemented from osgGA::GUIEventHandler.

virtual bool osgGA::TerrainManipulator::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| handle events, return true if handled, false otherwise. Reimplemented from osgGA::MatrixManipulator.

virtual void osgGA::TerrainManipulator::home | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| Move the camera to the default position. May be ignored by manipulators if home functionality is not appropriate. Reimplemented from osgGA::MatrixManipulator.

virtual void osgGA::TerrainManipulator::init | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| Start/restart the manipulator. Reimplemented from osgGA::MatrixManipulator.

bool osgGA::TerrainManipulator::isMouseMoving | ( |  | ) | `[protected]`

| Check the speed at which the mouse is moving. If speed is below a threshold then return false, otherwise return true.

virtual void osgGA::TerrainManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) | `[inline, virtual]`

| set the position of the matrix manipulator using a 4x4 Matrix. Implements osgGA::MatrixManipulator.

virtual void osgGA::TerrainManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) | `[virtual]`

| set the position of the matrix manipulator using a 4x4 Matrix. Implements osgGA::MatrixManipulator.

virtual void osgGA::TerrainManipulator::setNode | ( | osg::Node * |  | ) | `[virtual]`

| Attach a node to the manipulator. Automatically detaches previously attached node. setNode(NULL) detaches previously nodes. Is ignored by manipulators which do not require a reference model. Reimplemented from osgGA::MatrixManipulator.

void osgGA::TerrainManipulator::setRotationMode | ( | RotationMode | mode | ) |

double osgGA::TerrainManipulator::tb_project_to_sphere | ( | double | r,
|  | double | x,
|  | double | y
| ) | `[protected]`

void osgGA::TerrainManipulator::trackball | ( | osg::Vec3 & | axis,
|  | double & | angle,
|  | double | p1x,
|  | double | p1y,
|  | double | p2x,
|  | double | p2y
| ) | `[protected]`

## Member Data Documentation

osg::Vec3d osgGA::TerrainManipulator::_center`[protected]`

float osgGA::TerrainManipulator::_distance`[protected]`

osg::ref_ptr<const GUIEventAdapter> osgGA::TerrainManipulator::_ga_t0`[protected]`

osg::ref_ptr<const GUIEventAdapter> osgGA::TerrainManipulator::_ga_t1`[protected]`

osg::ref_ptr<osg::Node> osgGA::TerrainManipulator::_node`[protected]`

osg::Vec3d osgGA::TerrainManipulator::_previousUp`[protected]`

osg::Quat osgGA::TerrainManipulator::_rotation`[protected]`

RotationMode osgGA::TerrainManipulator::_rotationMode`[protected]`

bool osgGA::TerrainManipulator::_thrown`[protected]`

The documentation for this class was generated from the following file:

- TerrainManipulator